const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const udkService = require("./udk.service");

router.post("/create", authorize(), create);
router.get("/", authorize(), getAll);
router.get("/filter", authorize(), filter);
router.get("/filter-by-id", authorize(), filterByID);
router.get("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put("/enabled/:id", authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
  udkService
    .create(req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function getAll(req, res, next) {
  udkService
    .getAll(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

function filter(req, res, next) {
  udkService
    .filter(req.query)
    .then((result) => res.json(result))
    .catch(next);
}
function filterByID(req, res, next) {
  udkService
    .filterByID(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

function option(req, res, next) {
  udkService
    .option()
    .then((result) => res.json(result))
    .catch(next);
}

function count(req, res, next) {
  udkService
    .count()
    .then((result) => res.json(result))
    .catch(next);
}

function update(req, res, next) {
  udkService
    .update(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function enabled(req, res, next) {
  udkService
    .enabled(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function _delete(req, res, next) {
  udkService
    .delete(req.params.id)
    .then((result) => res.json(result))
    .catch(next);
}